﻿

class Math2 extends Math {
	
    /*
    * ##### Math_functions || Last Update: 17.03.06 von David #####
	*/

	static var wm = 180/Math.PI;

	// ------- 
	// Funktion -> Begrenzen eines Wertes zwischen min und max
	// Übergabe -> Wert, min, max
	// -------
	
	static function limit (val:Number, min:Number, max:Number) {
		return Math.min( max, Math.max( min, val ) );
	}

	static function hex2rgb ( h ) {
		return { r:h>>16, g:255&h>>8, b:255&h };
	}
	
	static function rgb2hex ( obj, g, b ) {
		if (g != undefined) var obj = { r:obj, g:g, b:b };
		return obj.r*256*256 + obj.g*256 + obj.b;
	}

	// 
	//

	static function get_line_point ( pt1, pt2, pos ) {
		var xb = pt2.x - pt1.x;
		var yb = pt2.y - pt1.y;
		return {x:pt1.x + xb * pos, y: pt1.y + yb * pos}
	}

	static function circle_position ( angle, rX, rY, cX, cY, tilt ) {
		angle -= 90;
		if (rX == undefined) rX = 1;
		if ((rY == undefined || rY == false) && rX != undefined) rY = rX;
		if (cX == undefined) cX = 0;
		if (cY == undefined) cY = 0;
		if (tilt == undefined) tilt = 0;
		
		var pt = {x:cX+Math.cos(angle/wm)*rX, y:cY+Math.sin(angle/wm)*rY};
		return tilt == 0 ? pt : point_rotation( pt, tilt, cX, cY);
	}
	
	static function simple_circle_position ( pt, angle, dist ) {
		var x = pt.x + dist * Math.cos( angle / (180/Math.PI) );
		var y = pt.y + dist * Math.sin( angle / (180/Math.PI) );
		return {x:x, y:y};
	}

	static function angle ( pt1, pt2 ) {
		if (pt1 instanceof MovieClip) pt1 = {x:pt1._x, y:pt1._y};
		if (pt2 instanceof MovieClip) pt2 = {x:pt2._x, y:pt2._y};
		var xb = pt1.x - pt2.x;
		var yb = pt1.y - pt2.y;
		if (xb == 0 && yb <= 0) return 0;
		if (xb == 0 && yb > 0) return 180;
		return 90+((90/(Math.PI/2))*Math.atan(yb/xb)) + (xb > 0 ? 180 : 0);
	}
	
/*
	static function angle ( pt, ct ) {
		if (pt instanceof MovieClip) pt = {x:pt._x, y:pt._y};
		if (ct instanceof MovieClip) ct = {x:ct._x, y:ct._y};
		
		var x = pt.x - ct.x;
		var y = pt.y - ct.y;
		var a = 0;
		if (x <> 0) a = 90+((90/(Math.PI/2))*Math.atan(y/x));
		if (x == 0 && y >= 0) a = 180;
		if (x < 0) a += 180;
		return a;
	}
*/
	static function distance ( pt, ct ) {
		if (pt instanceof MovieClip) pt = {x:pt._x, y:pt._y};
		if (ct instanceof MovieClip) ct = {x:ct._x, y:ct._y};
		var x = pt.x - ct.x;
		var y = pt.y - ct.y;
		return Math.sqrt(x*x + y*y);
	}
	
	static function point_rotation ( pt, r, cX, cY ) {
		
		if (cX == undefined) cX = 0;
		if (cY == undefined) cY = 0;
		
		var xx = cX - pt.x;
		var yy = cY - pt.y;
		
		if (xx == 0 && yy == 0) return {x:cX, y:cY};
		
		var d = -Math.sqrt( xx*xx + yy*yy );
		if (xx < 0) d *= -1;
	
		var w = Math.atan( yy/xx ) + r/(180/Math.PI);
		
		return { x:cX+Math.cos(w)*d, y:cY+Math.sin(w)*d };
	}
	
	static function wobble( c, i1, i2, off1, off2 ) {
		if (off1 == undefined) off1 = 0;
		if (off2 == undefined) off2 = 0;
		return {x:Math.cos(c*i1/wm + off1), y:Math.sin(c*i2/wm + off2)}
	}
	
	static function curve_parabel_inout ( c, d, fi, fo ) {
		return c <= d/2 ? 0.5/(Math.pow(4, fi) -1) * (Math.pow(4, fi * 1/(d/2)*c) -1) : 0.5 + 0.5/(Math.pow(4, -Math.abs(fo)) -1) * (Math.pow(4, -Math.abs(fo) * 1/(d/2)*(c-d/2)) -1);
	}

	
	static function bezier_curve_point ( pt, c, d ) {
		var a = 1-1/d*c;
		var b = 1-a;
		return {x:pt[0][0]*(a*a*a) + pt[1][0]*3*(a*a)*b + pt[2][0]*3*a*b*b + pt[3][0]*b*b*b, y:pt[0][1]*(a*a*a) + pt[1][1]*3*(a*a)*b + pt[2][1]*3*a*b*b + pt[3][1]*b*b*b }
	}


};


