﻿
class Shapes extends Math2 {
	
	
	// Rechteck zeichen, mit oder ohne Wölbungen
	// points 	= [ {x:.. , y:.. }, ... ]
	// magnets 	= [ {x:.. , y:.. }, ... ]
	
	static function rect ( mc, points, magnets ) {
		mc.moveTo( points[0].x, points[0].y );
		mc.beginFill( 0x000000 );
		
		for (var i = 1; i < 4; i++) {
			if (magnets[i-1] !== false && magnets[i-1] != undefined) {
				mc.curveTo( magnets[i-1].x, magnets[i-1].y, points[i].x, points[i].y );
			} else {
				mc.lineTo( points[i].x, points[i].y );
			}
		}
		mc.endFill();
	}
	
	
	static function stroke ( mc, fromPoint, toPoint, fromWidth, toWidth, bend ) {
		var r = Math2.angle( fromPoint, toPoint );
		var p = [];
		
		// Eckpunkte
		p[0] = Math2.simple_circle_position(  fromPoint, r, -fromWidth );
		p[1] = Math2.simple_circle_position(  toPoint, r, -toWidth );
		p[2] = Math2.simple_circle_position(  toPoint, r, toWidth );
		p[3] = Math2.simple_circle_position(  fromPoint, r, fromWidth );
	
		// Magnet-Punkte
		if (bend) {
			var linePoint = Math2.get_line_point( fromPoint, toPoint, 0.7 );
			p[4] = Math2.simple_circle_position( linePoint, r, bend );
			p[5] = Math2.simple_circle_position( linePoint, r, bend );
		}
		
		Shapes.rect( mc, p, [p[4], false, p[5], false]);
		return p;
	}



};


